; 
    include \masm32\include\masm32rt.inc
; 

    GethEdit MACRO
      push 2
      call QEinterface
      EXITM <eax>
    ENDM

  ; -----------------------------------------
  ; Prototype for the function to change text
  ; -----------------------------------------
    text_operation PROTO :DWORD

    .data?
      DLLinstance dd ?      ; DLL instance handle (unused)
      hEdit dd ?            ; main QE Edit handle

    .code

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 

    switch reason
      case DLL_PROCESS_ATTACH
        mrm DLLinstance,instance
        mov eax, TRUE
      endsw

    ret

LibMain endp

; 

PiEntryPoint proc QEinterface:DWORD

    mov hEdit, GethEdit()           ; get the QE edit handle

    invoke text_operation,hEdit     ; call the function to change text

    ret

PiEntryPoint endp

; 

text_operation proc Edit:DWORD

    LOCAL cr    :CHARRANGE          ; structure to store text selection from QE
    LOCAL tlen  :DWORD
    LOCAL ptxt  :DWORD

    invoke SendMessage,Edit,EM_EXGETSEL,0,ADDR cr   ; get the text selection range

    mov eax, cr.cpMax               ; load the end of the selection in EAX
    sub eax, cr.cpMin               ; subtract the start selection from it
    mov tlen, eax                   ; write the length to the length variable

    .if tlen == 0
      fn MessageBox,0,"No selected text to change","Problem",MB_OK
      ret
    .endif

    mov ptxt, alloc(tlen)           ; allocate memory to write selection to

    invoke SendMessage,Edit,EM_GETSELTEXT,0,ptxt    ; copy selected text into allocate buffer

  ; *******************************************************
  ; modify the selected text here but do NOT make
  ; it longer than the selected text length
  ; *******************************************************

    mov ptxt, rev$(ptxt)        ; reverse the text

    mov ptxt, ucase$(ptxt)      ; convert it to upper case

    mov ptxt, rev$(ptxt)        ; reverse it again

    mov ptxt, lcase$(ptxt)      ; reverse it back again

  ; -------------------------------
  ; do the same but all on one line
  ; -------------------------------
    ;;; mov ptxt, lcase$(rev$(ucase$(rev$(ptxt))))

  ; *******************************************************

    invoke SendMessage,Edit,EM_REPLACESEL,TRUE,ptxt ; replace the selection

  ; -------------------------------------------
  ; reset the selection for the new text length
  ; -------------------------------------------
    mov tlen, len(ptxt)             ; measure the modified text length

    mov eax, cr.cpMin               ; put the selection start in EAX
    add eax, tlen                   ; add length to EAX
    mov cr.cpMax, eax               ; set the new selection end

    invoke SendMessage,Edit,EM_EXSETSEL,0,ADDR cr

    free ptxt                       ; free the alocated memory

    ret

text_operation endp

; 
















end LibMain
